// FOUR HEROES (CARD GAME)
// By Banjo
// banjosbbs@hotmail.com
// www.banjosbbs.blogspot.com
// Version 1.10
//
// CREDITS:
// Script by Banjo, based on other SexScript game scripts by Marspank. Thanks to Liz and Doti for their additional code and help.
// Inspired by and based on the original Four Heroes/Red Peaches Club computer game by CM_Zero.
// Card images created by Banjo from various cosplay images found freely online; if you know the source or identity of any photo and want acknowledment, please let me know!
// Opponent images sourced from various free web preview galleries.
// Spanking sounds recorded and edited by Banjo.
// Card sounds from www.freesound.org, edited by Banjo from sounds originally recorded by F4ngy and Trevornau22fv.
//
// COPYRIGHT:
// This script, from http://ss.deviatenow.com, is protected by this licence:
// CC BY-NC-ND, see http://creativecommons.org/licenses/by-nc-nd/4.0/
// This copyright refers only to this script itself; it does not include any other included resources (images, music, sounds, etc.) which remain the property of their owners.
//
// SCRIPT RESOURCES
// This contains a list of files included with the script when published to the SexScripts website
/*
 * Resources
 * scripts/Banjo/fourheroes.groovy
 * images/cards/fourheroes/*.png
 */
//

//Metadata
setInfos(7, "Four Heroes",
	"A spanking card game, based on a game by CM_Zero (requires Game Hub)",
	"Banjo, CM_Zero",
	"v1.10", 0xFFFFFF, "en",
	["spanking", "game", "femaledom", "formale", "forfemale", "banjohub"]);

//Player setup
def player = (loadString("intro.name"))
def manlady = "man"
def boygirl = "boy"
def bratbitch = "brat"
def cockpussy = "cock"
if(loadBoolean("intro.female"))
{
	manlady = "lady"
	boygirl = "girl"
	bratbitch = "bitch"
	cockpussy = "pussy"
}

//Game Setup
def gamename = "Four Heroes"
def opponent_met = false
def opponent_played = false
def menu = 0
def quit = false
def greeting = "Ready to play?"
def table = "green"
def cardback = "cardback"
def hero = "Hero"
def sorceress = "Sorceress"
def knight = "Knight"
def witch = "Witch"
def darkknight = "Dark Knight"
def element = "Field"
def light = "Light"
def dark = "Dark"
def coins = "points"
def coin = "point"
def cardSorceress = "sorceress"
def cardKnight = "knight"
def cardWitch = "witch"
def cardDarkKnight = "darkknight"
def revealElement = true
def coinsBet = 1
def betPay = false
def coinsPlayer = 0
def coinsStart = 20
def coinsOpponentBonus = 0
def spankMultiplierLight = 2
def spankMultiplierHeavy = 1
def strokeMultiplier = 10
def flipCard = true

//Load settings
def loadSettings = {
	if(loadBoolean("Banjo.fourheroes.custom")) {
		coinsStart = loadInteger("Banjo.fourheroes.coinsStart")
		coinsOpponentBonus = loadInteger("Banjo.fourheroes.coinsOpponentBonus")
		coinsBet = loadInteger("Banjo.fourheroes.coinsBet")
		betPay = loadBoolean("Banjo.fourheroes.betPay")
		revealElement = loadBoolean("Banjo.fourheroes.revealElement")
		flipCard = loadBoolean("Banjo.fourheroes.flipCard")
		spankMultiplierLight = loadInteger("Banjo.fourheroes.spankMultiplierLight")
		spankMultiplierHeavy = loadInteger("Banjo.fourheroes.spankMultiplierHeavy")
		strokeMultiplier = loadInteger("Banjo.fourheroes.strokeMultiplier")
	}
}

//Game modes
def gameMode = 0
def tableStyle = 0
def checkMode = {
	if(loadInteger("Banjo.fourheroes.tableStyle")==1)
		table = "wood"
	else
		table = "green"
	if(loadInteger("Banjo.fourheroes.gameMode")==1) {
		hero = "Hero"
		sorceress = "Cleric"
		knight = "Warrior"
		witch = "Mage"
		darkknight = "Rogue"
		element = "Element"
		light = "Light"
		dark = "Dark"
		cardSorceress = "cleric"
		cardKnight = "warrior"
		cardWitch = "mage"
		cardDarkKnight = "rogue"
	}
	else if(loadInteger("Banjo.fourheroes.gameMode")==2) {
		hero = "Trooper"
		sorceress = "Medic"
		knight = "Soldier"
		witch = "Engineer"
		darkknight = "Infiltrator"
		element = "Time"
		light = "Day"
		dark = "Night"
		cardSorceress = "medic"
		cardKnight = "soldier"
		cardWitch = "engineer"
		cardDarkKnight = "infiltrator"
	}
	else {
		hero = "Hero"
		sorceress = "Sorceress"
		knight = "Knight"
		witch = "Witch"
		darkknight = "Dark Knight"
		element = "Field"
		light = "Light"
		dark = "Dark"
		cardSorceress = "sorceress"
		cardKnight = "knight"
		cardWitch = "witch"
		cardDarkKnight = "darkknight"
	}
}
if(loadBoolean("Banjo.fourheroes.custom")) {
	gameMode = loadInteger("Banjo.fourheroes.gameMode")
	checkMode()
}

//Check casino mode
def checkCasino = {
	if(loadBoolean("Banjo.games.casinoMode")) {
		coins = "chips"
		coin = "chip"
	}
	else {
		coins = "points"
		coin = "point"
	}
}

//Default implements
def lightImplement = "hairbrush"
def lightImplementSound = "smack"
def heavyImplement = "bathbrush"
def heavyImplementSound = "whack"

//Default opponent
def opponent="Gemma"
def opponent_pics = 5
def opponent_pics2 = 2
def respectTitle = "Miss"
def coinsOpponent = 20
def bluffChance = 4
def meet1 = "Hi, I'm "+opponent+"."
def meet2 = "\n\nWhat's your name?"
def meet3 = "It's nice to meet you, "+player+"."
def meet4 = "Let's play '"+gamename+"'."
def intro1 = "Hi there!\n\nLet's play '"+gamename+"'."
def backagain1 = "Want to play '"+gamename+"' with me again?"
def backagain2 = "Back for another game of '"+gamename+"'?"
def refuse1 = "Aww, too bad!\n\nMaybe some other time?"
def goodbye1 = "Now wasn't that a fun game?\n\nCome back soon so we can play again."

//Opponents
def maxOpponents = 13
def opponent0 = "Gemma"
def opponent1 = "Sandy"
def opponent2 = "Khyanna"
def opponent3 = "Raven"
def opponent4 = "Nicole"
def opponent5 = "Gracie"
def opponent6 = "Melanie"
def opponent7 = "Ann"
def opponent8 = "Valentina"
def opponent9 = "Kitty"
def opponent10 = "Bryci"
def opponent11 = "Tyler"
def opponent12 = "Tere"
def opponent13 = "Kiara"

def opponentSet0 = {
	opponent = "Gemma"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	coinsOpponent = 20
	bluffChance = 4
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet1 = {
	opponent = "Sandy"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	coinsOpponent = 20
	bluffChance = 4
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet2 =  {
	opponent = "Khyanna"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	coinsOpponent = 20
	bluffChance = 4
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet3 = 	{
	opponent = "Raven"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 2
	coinsOpponent = 20
	bluffChance = 4
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet4 = {
	opponent = "Nicole"
	respectTitle = "Miss"
	opponent_pics = 4
	opponent_pics2 = 2
	coinsOpponent = 20
	bluffChance = 4
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet5 = {
	opponent = "Gracie"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	coinsOpponent = 20
	bluffChance = 4
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet6 = {
	opponent = "Melanie"
	respectTitle = "Miss"
	opponent_pics = 6
	opponent_pics2 = 2
	coinsOpponent = 20
	bluffChance = 4
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet7 = {
	opponent = "Ann"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 3
	coinsOpponent = 20
	bluffChance = 4
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet8 = {
	opponent = "Valentina"
	respectTitle = "Miss"
	opponent_pics = 4
	opponent_pics2 = 2
	coinsOpponent = 20
	bluffChance = 4
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet9 = {
	opponent = "Kitty"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 3
	coinsOpponent = 20
	bluffChance = 4
	meet1 = "My name is "+opponent+"."
	meet2 = "\n\nWho the hell are you, "+bratbitch+"?"
	meet3 = "Hmph! Another silly little "+boygirl+"?"
	meet4 = "I assume you want to play '"+gamename+"' with me?"
	intro1 = "Hello, "+boygirl+"\n\nShall we play '"+gamename+"'?"
	backagain1 = "Do you want to play '"+gamename+"' again?"
	backagain2 = "Back for another game of '"+gamename+"', "+boygirl+"?"
	refuse1 = "Then run along and don't bother me, little "+boygirl+"."
	goodbye1 = "That was rather amusing.\n\nI might enjoy playing with you again."
}

def opponentSet10 = {
	opponent = "Bryci"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 3
	coinsOpponent = 20
	bluffChance = 4
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet11 = {
	opponent = "Tyler"
	respectTitle = "Miss"
	opponent_pics = 4
	opponent_pics2 = 2
	coinsOpponent = 20
	bluffChance = 4
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet12 = {
	opponent = "Tere"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 4
	coinsOpponent = 20
	bluffChance = 4
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet13 = {
	opponent = "Kiara"
	respectTitle = "Aunty"
	opponent_pics = 7
	opponent_pics2 = 4
	coinsOpponent = 20
	bluffChance = 4
	meet1 = "Hello there. I'm "+opponent+"... but you can call me '"+respectTitle+" "+opponent+"', young "+manlady+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

//Opponent selection menu
def opponentSelect = {
	def opponentselection = true
	while(opponentselection)
	{
		def pick_opponent = getSelectedValue("Select your opponent:", [opponent0,opponent1,opponent2,opponent3,opponent4,opponent5,opponent6,opponent7,opponent8,opponent9,opponent10,opponent11,opponent12,opponent13])
		if(pick_opponent==0) opponentSet0()
		else if(pick_opponent==1) opponentSet1()
		else if(pick_opponent==2) opponentSet2()
		else if(pick_opponent==3) opponentSet3()
		else if(pick_opponent==4) opponentSet4()
		else if(pick_opponent==5) opponentSet5()
		else if(pick_opponent==6) opponentSet6()
		else if(pick_opponent==7) opponentSet7()
		else if(pick_opponent==8) opponentSet8()
		else if(pick_opponent==9) opponentSet9()
		else if(pick_opponent==10) opponentSet10()
		else if(pick_opponent==11) opponentSet11()
		else if(pick_opponent==12) opponentSet12()
		else if(pick_opponent==13) opponentSet13()
		if(pick_opponent<(maxOpponents+1)) opponentselection = false
	}
}

//Config menu
def setCustom = {
	coinsStart = getInteger("Enter the number of "+coin+"s you start the game with.\n\n(default is 20, current is "+coinsStart+")",coinsStart)
	while(coinsStart<1) {
		coinsStart = getInteger("You must set the number of coints to 1 or higher!\n\n(default is 20)",coinsStart)
	}
	coinsOpponentBonus = getInteger("Enter the number of "+coin+"s to modify your opponent's starting "+coins+" by (this can be positive or negative to change difficulty).\n\n(default is 0, current is "+coinsOpponentBonus+")",coinsOpponentBonus)
	coinsBet = getInteger("Enter the number of "+coin+"s bet per round.\n\n(default is 1, current is "+coinsBet+")",coinsBet)
	while(coinsBet<0) {
		coinsBet = getInteger("You must set the number of "+coin+"s to 1 or higher!\n\n(default is 1)",coinsBet)
	}
	betPay = getBoolean("Do you want the round winner to gain "+coin+"s?\n\n(default is false, current is "+betPay+")", "True", "False")
	revealElement = getBoolean("Do you want you and your opponent to be shown the round's "+element+" before you choose your cards?\n\n(default is true, current is "+revealElement+")", "True", "False")
	spankMultiplierLight = getInteger("Enter the multiplier for light spanks.\n\n(default is 2, current is "+spankMultiplierLight+")",spankMultiplierLight)
	while(spankMultiplierLight<1) {
		spankMultiplierLight = getInteger("You must set the multiplier to 1 or higher!\n\n(default is 2)",spankMultiplierLight)
	}
	spankMultiplierHeavy = getInteger("Enter the multiplier for heavy spanks.\n\n(default is 1, current is "+spankMultiplierHeavy+")",spankMultiplierHeavy)
	while(spankMultiplierHeavy<1) {
		spankMultiplierHeavy = getInteger("You must set the multiplier to 1 or higher!\n\n(default is 1)",spankMultiplierHeavy)
	}
	strokeMultiplier = getInteger("Enter the multiplier for strokes.\n\n(default is 10, current is "+strokeMultiplier+")",strokeMultiplier)
	while(strokeMultiplier<1) {
		strokeMultiplier = getInteger("You must set the multiplier to 1 or higher!\n\n(default is 30)",strokeMultiplier)
	}
	def gameModeChoices = ["Original","Revised"]
//	gameModeChoices = gameModeChoices + ["Military"] //Future variation planned
	gameMode = getSelectedValue("Which version do you want to play?",gameModeChoices)
	tableStyle = getSelectedValue("Which tabletop do you want to use?",["Green Felt","Wood"])
	flipCard = getBoolean("Do you want your opponent's card to be realistically 'flipped' visually?\n\n(default is true, current is "+flipCard+")", "True", "False")
	save("Banjo.fourheroes.coinsStart",coinsStart)
	save("Banjo.fourheroes.coinsOpponentBonus",coinsOpponentBonus)
	save("Banjo.fourheroes.coinsBet",coinsBet)
	save("Banjo.fourheroes.betPay",betPay)
	save("Banjo.fourheroes.revealElement",revealElement)
	save("Banjo.fourheroes.flipCard",flipCard)
	save("Banjo.fourheroes.spankMultiplierLight",spankMultiplierLight)
	save("Banjo.fourheroes.spankMultiplierHeavy",spankMultiplierHeavy)
	save("Banjo.fourheroes.strokeMultiplier",strokeMultiplier)
	save("Banjo.fourheroes.gameMode",gameMode)
	save("Banjo.fourheroes.tableStyle",tableStyle)
	save("Banjo.fourheroes.custom",true)
	checkMode()
	checkCasino()
	show("Settings saved.")
	wait(3)
	loadSettings()
}

def resetGame = {
	coinsStart = 20
	coinsOpponentBonus = 0
	coinsBet = 1
	betPay = false
	revealElement = true
	flipCard = true
	spankMultiplierLight = 2
	spankMultiplierHeavy = 1
	strokeMultiplier = 10
	opponent_played = false
	save("Banjo.fourheroes.implements_set",false)
	save("Banjo.fourheroes.coinsStart",coinsStart)
	save("Banjo.fourheroes.coinsOpponentBonus",coinsOpponentBonus)
	save("Banjo.fourheroes.coinsBet",coinsBet)
	save("Banjo.fourheroes.betPay",betPay)
	save("Banjo.fourheroes.revealElement",revealElement)
	save("Banjo.fourheroes.flipCard",flipCard)
	save("Banjo.fourheroes.spankMultiplierLight",spankMultiplierLight)
	save("Banjo.fourheroes.spankMultiplierHeavy",spankMultiplierHeavy)
	save("Banjo.fourheroes.strokeMultiplier",strokeMultiplier)
	save("Banjo.fourheroes.gameMode",0)
	save("Banjo.fourheroes.tableStyle",0)
	checkMode()
	checkCasino()
	save("Banjo.fourheroes.custom",false)
	save("Banjo.fourheroes.played_"+opponent0+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent1+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent2+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent3+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent4+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent5+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent6+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent7+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent8+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent9+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent10+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent11+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent12+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent13+"",opponent_played)
	show("Settings reset to defaults.\n\nGame will quit after exiting config.")
	wait(5)
	quit = true
}

def resetTotal = {
	coinsStart = 20
	coinsOpponentBonus = 0
	coinsBet = 1
	betPay = false
	revealElement = true
	flipCard = false
	spankMultiplierLight = 2
	spankMultiplierHeavy = 1
	strokeMultiplier = 10
	opponent_met = false
	opponent_played = false
	save("Banjo.fourheroes.implements_set",false)
	save("Banjo.fourheroes.coinsStart",coinsStart)
	save("Banjo.fourheroes.coinsOpponentBonus",coinsOpponentBonus)
	save("Banjo.fourheroes.coinsBet",coinsBet)
	save("Banjo.fourheroes.betPay",betPay)
	save("Banjo.fourheroes.revealElement",revealElement)
	save("Banjo.fourheroes.flipCard",flipCard)
	save("Banjo.fourheroes.spankMultiplierLight",spankMultiplierLight)
	save("Banjo.fourheroes.spankMultiplierHeavy",spankMultiplierHeavy)
	save("Banjo.fourheroes.strokeMultiplier",strokeMultiplier)
	save("Banjo.fourheroes.gameMode",0)
	save("Banjo.fourheroes.tableStyle",0)
	checkMode()
	checkCasino()
	save("Banjo.fourheroes.custom",false)
	save("Banjo.fourheroes.played_"+opponent0+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent1+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent2+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent3+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent4+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent5+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent6+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent7+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent8+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent9+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent10+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent11+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent12+"",opponent_played)
	save("Banjo.fourheroes.played_"+opponent13+"",opponent_played)
	save("Banjo.games.met_"+opponent0+"",opponent_met)
	save("Banjo.games.met_"+opponent1+"",opponent_met)
	save("Banjo.games.met_"+opponent2+"",opponent_met)
	save("Banjo.games.met_"+opponent3+"",opponent_met)
	save("Banjo.games.met_"+opponent4+"",opponent_met)
	save("Banjo.games.met_"+opponent5+"",opponent_met)
	save("Banjo.games.met_"+opponent6+"",opponent_met)
	save("Banjo.games.met_"+opponent7+"",opponent_met)
	save("Banjo.games.met_"+opponent8+"",opponent_met)
	save("Banjo.games.met_"+opponent9+"",opponent_met)
	save("Banjo.games.met_"+opponent10+"",opponent_met)
	save("Banjo.games.met_"+opponent11+"",opponent_met)
	save("Banjo.games.met_"+opponent12+"",opponent_met)
	save("Banjo.games.met_"+opponent13+"",opponent_met)
	show("Settings reset to defaults.")
	wait(5)
	quit = true
}

def changeSettings = {
	def loopmenu = true
	while(loopmenu) {
		menu = getSelectedValue("What do you want to do?", ["Exit Config", "Customize", "Reset Game", "Total Reset"])
		if(menu==0) loopmenu = false
		else if(menu==1) setCustom()
		else if(menu==2) resetGame()
		else if(menu==3) resetTotal()
	}
}

//Card Sounds
def playSoundCardShuffle = {
	playBackgroundSound("banjo/casino/card_shuffle.wav")
}

def playSoundCardDeal = {
	playBackgroundSound("banjo/casino/card_deal.wav")
}

def playSoundCardFlip = {
	playBackgroundSound("banjo/casino/card_flip.wav")
}

//Basic variables and definitions
def gamePlay = false
def round = 0
def wins = 0
def losses = 0

def getRandomItem = { itemKeys ->
	for ( key in itemKeys ) {
		if ( !loadBoolean(key) ) itemKeys -= key
	}
	if ( itemKeys.isEmpty() ) return null
	return itemKeys[ getRandom(itemKeys.size()) ]
}

def spankImplement = lightImplement
def spankSound = lightImplementSound
def spankSoundLimit = 4

def x = 0
def spank = {
	message, spanks, time ->
	show(""+message+"\n\n. . ")
	wait(3)
	(1..spanks).each {
		x++
		show(message+"\n\n."+x+".")
		playBackgroundSound("spanks/"+spankSound+(1+getRandom(spankSoundLimit))+".wav")
		wait(time)
	}
}

def stroke = {
	message, strokes, time ->
	show(""+message+"\n\n. . ")
	wait(time)
	(1..strokes).each {
		x++
		show(message+"\n\n."+x+".")
		playBackgroundSound("tom.wav")
		wait(time)
	}
}

//Randomly select an image
def setImageGame = {
	def imageNumber = getRandom(opponent_pics)+1
	setImage("opponents/"+opponent+"_playing"+imageNumber+".jpg")
}

//Show main opponent image
def setImageMain = {
	setImage("opponents/"+opponent+"_intro.jpg")
}

def setImageSpank = {
	def imageNumber = getRandom(opponent_pics2)+1
	setImage("opponents/"+opponent+"_spank"+imageNumber+".jpg")
}

//Show table
def setImageTable = {
	setImage("cards/fourheroes/table-"+table+".png")
}

//Show cards
def setImageCards = { tabletop, card1, card2 ->
	//Tabletop image
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+tabletop)
	def width = image.getWidth()
	def height = image.getHeight()
	//Opponent card image
	def image1 = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+card1)
	def width1 = image1.getWidth()
	def height1 = image1.getHeight()
	def xpos1 = 8
	def ypos1 = 8
	if(flipCard) {
		xpos1 = xpos1 + image1.getWidth()
		ypos1 = ypos1 + image1.getHeight()
	}
	//Player card image
	def image2 = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+card2)
	def width2 = image2.getWidth()
	def height2 = image2.getHeight()
	def xpos2 = image2.getWidth() + 8
	def ypos2 = image2.getHeight() + 8
	//Display images
	def frameBuffer = new java.awt.image.BufferedImage(width, height, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
	def sprite = javax.imageio.ImageIO.read(new File("images/"+tabletop))
	def sprite1 = javax.imageio.ImageIO.read(new File("images/"+card1))
	def sprite2 = javax.imageio.ImageIO.read(new File("images/"+card2))
	java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	graphics.drawImage(sprite,0,0,width,height, null)
	if(flipCard)
		graphics.drawImage(sprite1,xpos1,ypos1,-width1,-height1, null)
	else
		graphics.drawImage(sprite1,xpos1,ypos1,width1,height1, null)
	graphics.drawImage(sprite2,xpos2,ypos2,width2,height2, null)
	
	java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
	javax.imageio.ImageIO.write(frameBuffer, "png", baos)
	setImage(baos.toByteArray(),0)
}

def playerCardImage
def opponentCardImage

def setImageCardBlank = {
	setImageCards("cards/fourheroes/table-"+table+".png","cards/fourheroes/"+cardback+".png","cards/fourheroes/"+cardback+".png")
}

def setImageCardDeal1 = {
	playSoundCardDeal()
	setImageCards("cards/fourheroes/table-"+table+".png","cards/fourheroes/"+cardback+".png","cards/fourheroes/cardblank.png")
}

def setImageCardDeal2 = {
	playSoundCardDeal()
	setImageCards("cards/fourheroes/table-"+table+".png","cards/fourheroes/"+cardback+".png","cards/fourheroes/"+cardback+".png")
}

def setImageCardPlayer = {
	playSoundCardFlip()
	setImageCards("cards/fourheroes/table-"+table+".png","cards/fourheroes/"+cardback+".png",playerCardImage)
}

def setImageCardOpponent = {
	playSoundCardFlip()
	setImageCards("cards/fourheroes/table-"+table+".png",opponentCardImage,playerCardImage)
}

//Game Intro
def intro = {
	if(!loadBoolean("Banjo.games.met_"+opponent+"")) {
		opponent_met = false
		save("Banjo.games.met_"+opponent+"",true)
	} else opponent_met = true
	if(!loadBoolean("Banjo.fourheroes.played_"+opponent+"")) {
		opponent_played = false
		save("Banjo.fourheroes.played_"+opponent+"",true)
	} else opponent_played = true
	if(!opponent_met) {
		show(meet1+meet2)
		showButton("I'm "+player+", "+respectTitle+".")
		show(meet3)
		wait(3)
		greeting = meet4
	} else if(!opponent_played) {
		greeting = intro1
	} else {
		def backagainMessageArray = [backagain1,backagain2]
		greeting = backagainMessageArray[getRandom(2)]
	}
	def mainmenu = true
	while(mainmenu) {
		loadSettings()
		menu = getSelectedValue(greeting, ["Yes", "No", "Config"])
		if(menu==0)
			mainmenu = false
		else if(menu==1) {
			show(refuse1)
			wait(5)
			mainmenu = false
			quit = true
		}
		else if(menu==2)
			changeSettings()
	}
}

//Rules explaination
def rulesDisplay = {
	show("'"+gamename+"' is a card-based variation on the classic 'rock, paper, scissors' game."
		+"\n\nIt was originally designed by 'CM_Zero', who made a computer game version "
		+"of it called 'Red Peaches Club'. I'm sure you can find it online if you want to give it a try."
		+"\n\nBut today, you and I will be playing this game for real!")
	showButton("Sounds interesting, "+respectTitle+".")
	show("To play, we each secretly choose one of four "+hero+" cards and lay them face down."
		+"\n\nThere are four "+hero+" cards:"
		+"\n\t - "+sorceress+"\n\t - "+knight+"\n\t - "+witch+"\n\t - "+darkknight+"")
	showButton("I understand, "+respectTitle+".")
	show("One we've both chosen a card, we flip them over to see who wins the round:"
		+"\n\n\t - "+sorceress+" beats "+knight+"."
		+"\n\t - "+knight+" beats "+witch+"."
		+"\n\t - "+darkknight+" beats "+sorceress+"."
		+"\n\t - "+witch+" beats "+darkknight+".")
	showButton("But what about...")
	show("When a "+sorceress+" opposes a "+witch+", or a "+knight+" opposes a "+darkknight+", however, things get interesting!"
		+"\n\nWhich one wins in that case is decided by the "+element+" of the round.")
	showButton("The '"+element+"', "+respectTitle+"?")
	if(revealElement) show("Each round has its own "+element+": either "+light+" or "+dark+"."
		+"\n\nThis changes at random for each round, but will be revealed before we choose our "+hero+" cards."
		+"\n\nIf the "+element+" is "+light+":"
		+"\n\t - "+knight+" beats "+darkknight+"."
		+"\n\t - "+sorceress+" beats "+witch+"."
		+"\n\nIf the "+element+" is "+dark+":"
		+"\n\t - "+darkknight+" beats "+knight+"."
		+"\n\t - "+witch+" beats "+sorceress+".")
	else show("Each round has its own "+element+": either "+light+" or "+dark+"."
		+"\n\nThis changes at random for each round, but will only be revealed after we choose our "+hero+" cards."
		+"\n\nIf the "+element+" is "+light+":"
		+"\n\t - "+knight+" beats "+darkknight+"."
		+"\n\t - "+sorceress+" beats "+witch+"."
		+"\n\nIf the "+element+" is "+dark+":"
		+"\n\t - "+darkknight+" beats "+knight+"."
		+"\n\t - "+witch+" beats "+sorceress+".")
	showButton("I see, "+respectTitle+".")
	if(betPay) {
		if(coinsBet==1)	show("To make the game more exciting, we will wager "+coins+"."
			+"\n\nEach round, we will both bet "+coinsBet+" "+coin+"."
			+"\n\nThe loser of a round loses "+coinsBet+" "+coin+"."
			+"\n\nThe winner of a round gains "+coinsBet+" "+coin+"."
			+"\n\nIf the round is a tie, nobody wins or loses any "+coin+"s."
			+"\n\nOnce someone has lost all their "+coins+", they lose the game and their opponent is the winner.")
		else show("To make the game more exciting, we will wager "+coins+"."
			+"\n\nThe loser of a round loses "+coinsBet+" "+coin+"s."
			+"\n\nThe winner of a round gains "+coinsBet+" "+coin+"s."
			+"\n\nIf the round is a tie, nobody wins or loses any "+coin+"s."
			+"\n\nOnce someone has lost all their "+coins+", they lose the game and their opponent is the winner.")
	} else {
		if(coinsBet==1)	show("To make the game more exciting, we will wager "+coins+"."
			+"\n\nWhenever someone loses a round, they lose "+coinsBet+" "+coin+"."
			+"\n\nOnce someone has lost all their "+coin+"s, they lose the game and their opponent is the winner.")
		else show("To make the game more exciting, we will wager "+coin+"s."
			+"\n\nWhenever someone loses a round, they lose "+coinsBet+" "+coin+"s."
			+"\n\nOnce someone has lost all their "+coins+", they lose the game and their opponent is the winner.")
	}
	showButton("I understand, "+respectTitle+".")
	def coinsOpponentTotal = coinsOpponent + coinsOpponentBonus
	show("You will start the game with "+coinsStart+" "+coin+"s."
		+"\n\nI will start with "+coinsOpponentTotal+" "+coin+"s.")
	showButton("Yes, "+respectTitle+".")
	show("Oh, one last thing...\n\nIf you lose the game, you will get a forfeit spanking!"
		+"\n\nHow severe a spanking? Well, that depends on how many "+coin+"s I have at the end of the game."
		+"\n\nYou will get "+spankMultiplierLight+" swats with a light implement and "+spankMultiplierHeavy+" swats with a heavy implement "
		+"for every "+coin+" I have left!")
	showButton("(Gulp!)")
	if(strokeMultiplier==1) show("However, if you win, you won't get a spanking at all!"
		+"\n\nInstead, I will allow you to stroke your "+cockpussy+" a number of times equal to however "
		+"many "+coin+"s you have left at the end of the game.")
	else show("Don't worry... if you win, you won't get a spanking at all!"
		+"\n\nInstead, I will allow you to stroke your "+cockpussy+" a number of times equal to however "
		+"many "+coin+"s you have left at the end of the game, multiplied by "+strokeMultiplier+".")
	showButton("Thank you, "+respectTitle+".")
}

//Implement sound assignments
def setImplementSound = {
	if(spankImplement=="hairbrush") spankSound = "smack"
	else if(spankImplement=="paddle hairbrush") spankSound = "smack"
	else if(spankImplement=="plastic hairbrush") spankSound = "slap"
	else if(spankImplement=="ruler") spankSound = "whap"
	else if(spankImplement=="spatula") spankSound = "slap"
	else if(spankImplement=="wooden spatula") spankSound = "slap"
	else if(spankImplement=="flyswatter") spankSound = "slap"
	else if(spankImplement=="wooden spoon") spankSound = "whap"
	else if(spankImplement=="bathbrush") spankSound = "whack"
	else if(spankImplement=="slipper") spankSound = "smack"
	else if(spankImplement=="sandal") spankSound = "smack"
	else if(spankImplement=="plimsoll") spankSound = "smack"
	else if(spankImplement=="sneaker") spankSound = "smack"
	else if(spankImplement=="leather slapper") spankSound = "slap"
	else if(spankImplement=="leather paddle") spankSound = "slap"
	else if(spankImplement=="table tennis bat") spankSound = "smack"
	else if(spankImplement=="paddleball bat") spankSound = "smack"
	else if(spankImplement=="battledore bat") spankSound = "whack"
	else if(spankImplement=="beach tennis bat") spankSound = "smack"
	else if(spankImplement=="paddle") spankSound = "whack"
	else if(spankImplement=="paddle with holes") spankSound = "whack"
	else if(spankImplement=="lexan paddle") spankSound = "whack"
	else if(spankImplement=="plastic paddle") spankSound = "smack"
	else if(spankImplement=="rubber paddle") spankSound = "smack"
	else if(spankImplement=="strap") spankSound = "belt"
	else if(spankImplement=="studded strap") spankSound = "belt"
	else if(spankImplement=="loop strap") spankSound = "slap"
	else if(spankImplement=="belt") spankSound = "belt"
	else if(spankImplement=="tawse") spankSound = "flog"
	else if(spankImplement=="cane") spankSound = "thwack"
	else if(spankImplement=="judicial cane") spankSound = "thwack"
	else if(spankImplement=="duster handle") spankSound = "thwack"
	else if(spankImplement=="short cane") spankSound = "thwack"
	else if(spankImplement=="plastic cane") spankSound = "thwack"
	else if(spankImplement=="loop cane") spankSound = "thwack"
	else if(spankImplement=="riding crop") spankSound = "thwip"
	else if(spankImplement=="birch rod") spankSound = "thwip"
	else if(spankImplement=="curtain rod") spankSound = "thwip"
	else if(spankImplement=="switch") spankSound = "thwip"
	else if(spankImplement=="rugbeater") spankSound = "thwack"
	else if(spankImplement=="martinet") spankSound = "thwip"
	else if(spankImplement=="flogger") spankSound = "flog"
	else if(spankImplement=="cat-o-nine-tails") spankSound = "flog"
	else if(spankImplement=="whip") spankSound = "flog"
	else spankSound="smack"
}

def setImplementSounds = {
	spankImplement = lightImplement
	setImplementSound()
	lightImplementSound = spankSound
	spankImplement = heavyImplement
	setImplementSound()
	heavyImplementSound = spankSound

}

//Mistress chooses implements
def pickImplementsMistress = {
	def implement
	//Random base implement
	def toysLight = ["toys.ruler","toys.wooden_spoon","toys.spatula","toys.spatula_wooden","toys.flyswatter",
		"toys.slipper","toys.sandal","toys.plimsoll","toys.sneaker",
		"toys.slapper","toys.strap_loop","toys.paddle_leather","toys.paddle_plastic",
		"toys.bat","toys.bat_flyback","toys.bat_battledore","toys.bat_beach",
		"toys.hairbrush","toys.hairbrush_plastic","toys.hairbrush_paddle"]
	implement = getRandomItem(toysLight)
	if(implement == "toys.ruler") lightImplement = "ruler"
	else if(implement == "toys.wooden_spoon") lightImplement = "wooden spoon"
	else if(implement == "toys.spatula") lightImplement = "spatula"
	else if(implement == "toys.spatula_wooden") lightImplement = "spatula"
	else if(implement == "toys.flyswatter") lightImplement = "flyswatter"
	else if(implement == "toys.slipper") lightImplement = "slipper"
	else if(implement == "toys.sandal") lightImplement = "sandal"
	else if(implement == "toys.plimsoll") lightImplement = "plimsoll"
	else if(implement == "toys.sneaker") lightImplement = "sneaker"
	else if(implement == "toys.slapper") lightImplement = "leather slapper"
	else if(implement == "toys.strap_loop") lightImplement = "looped strap"
	else if(implement == "toys.paddle_leather") lightImplement = "leather paddle"
	else if(implement == "toys.paddle_plastic") lightImplement = "plastic paddle"
	else if(implement == "toys.bat") lightImplement = "table tennis bat"
	else if(implement == "toys.bat_flyback") lightImplement = "paddleball bat"
	else if(implement == "toys.bat_jokari") lightImplement = "battledore bat"
	else if(implement == "toys.bat_beach") lightImplement = "beach tennis bat"
	else if(implement == "toys.hairbrush") lightImplement = "hairbrush"
	else if(implement == "toys.hairbrush_paddle") lightImplement = "paddle hairbrush"
	else if(implement == "toys.hairbrush_plastic") lightImplement = "plastic hairbrush"
	if(implement == null) lightImplement = getString("You don't have any of the implements I was looking for.\n\nEnter a light implement:", lightImplement)
	//Random heavy implement
	def toysHeavy = ["toys.paddle","toys.paddle_holes","toys.paddle_lexan","toys.bathbrush",
		"toys.strap","toys.strap_studded","toys.belt","toys.tawse","toys.paddle_rubber",
		"toys.crop","toys.switch","toys.birch","toys.rugbeater","toys.rod","toys.duster",
		"toys.cane","toys.cane_heavy","toys.cane_otk","toys.cane_plastic","toys.cane_loop",
		"toys.martinet","toys.flogger","toys.cat_o_nine","toys.whip"]
	implement = getRandomItem(toysHeavy)
	if(implement == "toys.paddle") heavyImplement = "paddle"
	else if(implement == "toys.paddle_holes") heavyImplement = "paddle with holes"
	else if(implement == "toys.paddle_lexan") heavyImplement = "lexan paddle"
	else if(implement == "toys.bathbrush") heavyImplement = "bathbrush"
	else if(implement == "toys.strap") heavyImplement = "strap"
	else if(implement == "toys.strap_studded") heavyImplement = "studded strap"
	else if(implement == "toys.belt") heavyImplement = "belt"
	else if(implement == "toys.tawse") heavyImplement = "tawse"
	else if(implement == "toys.paddle_rubber") heavyImplement = "rubber paddle"
	else if(implement == "toys.crop") heavyImplement = "riding crop"
	else if(implement == "toys.switch") heavyImplement = "switch"
	else if(implement == "toys.birch") heavyImplement = "birch rod"
	else if(implement == "toys.rugbeater") heavyImplement = "rugbeater"
	else if(implement == "toys.rod") heavyImplement = "curtain rod"
	else if(implement == "toys.duster") heavyImplement = "duster handle"
	else if(implement == "toys.cane") heavyImplement = "cane"
	else if(implement == "toys.cane_heavy") heavyImplement = "judicial cane"
	else if(implement == "toys.cane_otk") heavyImplement = "short cane"
	else if(implement == "toys.cane_plastic") heavyImplement = "plastic cane"
	else if(implement == "toys.cane_loop") heavyImplement = "loop cane"
	else if(implement == "toys.martinet") heavyImplement = "martinet"
	else if(implement == "toys.flogger") heavyImplement = "flogger"
	else if(implement == "toys.cat_o_nine") heavyImplement = "cat-o-nine-tails"
	else if(implement == "toys.whip") heavyImplement = "whip"
	if(implement == null) heavyImplement = getString("You don't have any of the implements I was looking for.\n\nEnter a heavy implement:", heavyImplement)
}

//Player chooses implements
def pickImplementsPlayer = {
	lightImplement = getString("Enter a light implement:", lightImplement)
	heavyImplement = getString("Enter a heavy implement:", heavyImplement)
}

//Implement selection
def pickImplementsChoice = {
	if(getBoolean("Do you want to me to pick the implements for you, based on what you have?\n\nOr do you want to choose them yourself?",
	"You pick","I'll pick")) pickImplementsMistress()
	else pickImplementsPlayer()
}

def pickImplements = {
	pickImplementsChoice()
	setImplementSounds()
	save("Banjo.fourheroes.lightImplement",lightImplement)
	save("Banjo.fourheroes.heavyImplement",heavyImplement)
	save("Banjo.fourheroes.implements_set",true)
	show("Okay. I've decided that you'll be spanked with the "+lightImplement+" and the "+heavyImplement+" if you lose.")
	showButton("I have them ready, "+respectTitle+".")
}

//Set starting coins
def setCoins = {
	if(loadBoolean("Banjo.games.casinoMode")) {
		coinsPlayer = loadInteger("Banjo.games.casinoChips")
	}
	else
		coinsPlayer = coinsStart
	coinsOpponent = coinsOpponent + coinsOpponentBonus
}

//Game round
def gameRound = {
	show("You: "+coinsPlayer+" "+coin+"s.\n"+opponent+": "+coinsOpponent+" "+coin+"s."
		+"\n\n\n\n\n\n\n\n...")
	//Setup choices
	def winner = "tie"
	def cards = [sorceress,knight,witch,darkknight]
	def elements = [light,dark]
	//Determine Element
	def roundElement = elements[getRandom(2)]
	def elementInfo = "\n\n"
	if(revealElement)
		elementInfo = "\n\n"+element+": "+roundElement+"."
	//Show Table
	setImageTable()
	def thinkMessageArray = ["Hmmm...",
		"Which card should I choose?",
		"..."]
	show("You: "+coinsPlayer+" "+coin+"s.\n"+opponent+": "+coinsOpponent+" "+coin+"s."
		+""+elementInfo+""
		+"\n\n\n\n\n\n"+thinkMessageArray[getRandom(3)]+"")
	def opponentThinks = getRandom(3)+2
	wait(opponentThinks)
	show("You: "+coinsPlayer+" "+coin+"s.\n"+opponent+": "+coinsOpponent+" "+coin+"s."
		+""+elementInfo+""
		+"\n\n\n\n\n\nOkay, I've chosen my card.")
	setImageCardDeal1()
	wait(1)
	//Player chooses card
	def playerAction
	playerAction = getSelectedValue("You: "+coinsPlayer+" "+coin+"s.\n"+opponent+": "+coinsOpponent+" "+coin+"s."
		+""+elementInfo+""
		+"\n\n\n\n\n\nWhich card will you play?", cards)
	def playerCard = cards[playerAction]
	//Set player card image
	if(playerCard==sorceress)
		playerCardImage = "cards/fourheroes/card-"+cardSorceress+".png"
	else if(playerCard==knight)
		playerCardImage = "cards/fourheroes/card-"+cardKnight+".png"
	else if(playerCard==witch)
		playerCardImage = "cards/fourheroes/card-"+cardWitch+".png"
	else if(playerCard==darkknight)
		playerCardImage = "cards/fourheroes/card-"+cardDarkKnight+".png"
	//Opponent chooses card
	def opponentCard
	if(revealElement) {
		def opponentDecision = getRandom(6)+1
		if(opponentDecision<=bluffChance) {
			if(roundElement==light)
				opponentCard = cards[getRandom(2)]
			else
				opponentCard = cards[getRandom(2)+2]
		}
		else opponentCard = cards[getRandom(4)]
	}
	else
		opponentCard = cards[getRandom(4)]
	//Set opponent card image
	if(opponentCard==sorceress)
		opponentCardImage = "cards/fourheroes/card-"+cardSorceress+".png"
	else if(opponentCard==knight)
		opponentCardImage = "cards/fourheroes/card-"+cardKnight+".png"
	else if(opponentCard==witch)
		opponentCardImage = "cards/fourheroes/card-"+cardWitch+".png"
	else if(opponentCard==darkknight)
		opponentCardImage = "cards/fourheroes/card-"+cardDarkKnight+".png"
	//Reveal Element
	setImageCardDeal2()
	wait(1)
	elementInfo = "\n\n"+element+": "+roundElement+"."
	//Reveal Cards
	show("You: "+coinsPlayer+" "+coin+"s.\n"+opponent+": "+coinsOpponent+" "+coin+"s."
		+""+elementInfo+""
		+"\n\n\n\n\n\nRevealing cards...")
	wait(1)
	setImageCardPlayer()
	wait(1)
	setImageCardOpponent()
	wait(1)
	//Determine round winner
		//Player played Sorceress
	if((playerCard==sorceress) && (opponentCard==sorceress)) winner = "tie"
	else if((playerCard==sorceress) && (opponentCard==knight)) winner = "player"
	else if((playerCard==sorceress) && (opponentCard==witch)) {
		if(roundElement==dark) winner = "opponent"
		else winner = "player"
	}
	else if((playerCard==sorceress) && (opponentCard==darkknight)) winner = "opponent"
		//Player played Knight
	if((playerCard==knight) && (opponentCard==sorceress)) winner = "opponent"
	else if((playerCard==knight) && (opponentCard==knight)) winner = "tie"
	else if((playerCard==knight) && (opponentCard==witch)) winner = "player"
	else if((playerCard==knight) && (opponentCard==darkknight)) {
		if(roundElement==dark) winner = "opponent"
		else winner = "player"
	}
		//Player played Witch
	if((playerCard==witch) && (opponentCard==sorceress)) {
		if(roundElement==dark) winner = "player"
		else winner = "opponent"
	}
	else if((playerCard==witch) && (opponentCard==knight)) winner = "opponent"
	else if((playerCard==witch) && (opponentCard==witch)) winner = "tie"
	else if((playerCard==witch) && (opponentCard==darkknight)) winner = "player"
		//Player played Dark Knight
	if((playerCard==darkknight) && (opponentCard==sorceress)) winner = "player"
	else if((playerCard==darkknight) && (opponentCard==knight)) {
		if(roundElement==dark) winner = "player"
		else winner = "opponent"
	}
	else if((playerCard==darkknight) && (opponentCard==witch)) winner = "opponent"
	else if((playerCard==darkknight) && (opponentCard==darkknight)) winner = "tie"
	//Display round winner
	def winnerTieMessage = ""+playerCard+" versus "+opponentCard+"."
	def winnerOpponentMessage = ""+opponentCard+" beats "+playerCard+"!"
	def winnerPlayerMessage = ""+playerCard+" beats "+opponentCard+"!"
	def winnerTieMessageArray = ["It's a tie!","A tie!", "A draw!"]
	def winnerOpponentMessageArray = ["I win!","I won that one.", "You lose!"]
	def winnerPlayerMessageArray = ["You win!","You won that one.", "I lost!"]
	def winnerMessageStart
	def winnerMessageArray
	if(winner=="tie") {
		winnerMessageStart = winnerTieMessage
		winnerMessageArray = winnerTieMessageArray
	}
	else if(winner=="opponent") {
		winnerMessageStart = winnerOpponentMessage
		winnerMessageArray = winnerOpponentMessageArray
	}
	else if(winner=="player") {
		winnerMessageStart = winnerPlayerMessage
		winnerMessageArray = winnerPlayerMessageArray
	}
	show("You: "+coinsPlayer+" "+coin+"s.\n"+opponent+": "+coinsOpponent+" "+coin+"s."
		+"\n\n"+element+": "+roundElement+"."
		+"\n\nYou play: "+playerCard+"."
		+"\n\t"+opponent+" plays: "+opponentCard+"."
		+"\n\n"+winnerMessageStart+""
		+"\n"+winnerMessageArray[getRandom(3)]+"")
	showButton("(Continue)")
	//Loser loses coin(s), winner gains coin(s)
	if(betPay) {
		if(winner=="player") {
			coinsPlayer = coinsPlayer + coinsBet
			coinsOpponent = coinsOpponent - coinsBet
		}
		else if(winner=="opponent") {
			coinsPlayer = coinsPlayer - coinsBet
			coinsOpponent = coinsOpponent + coinsBet
		}
	} else {
		if(winner=="player") {
			coinsOpponent = coinsOpponent - coinsBet
		}
		else if(winner=="opponent") {
			coinsPlayer = coinsPlayer - coinsBet
		}
	}
}

//Player lost the game and is spanked
def payoutSpank = {
	//Spanks are the number of coins opponent has left times implement multiplier
	def spanksLight = coinsOpponent * spankMultiplierLight
	def spanksHeavy = coinsOpponent * spankMultiplierHeavy
	def spanks = 0
	def implementArray = [lightImplement,heavyImplement]
	for(i in 0..2)
	{
		x = 0
		setImageGame()
		show("Grab the "+implementArray[i]+".")
		showButton("I have it, "+respectTitle+".")
		if(i==0) {
			spankSound = lightImplementSound
			spanks = spanksLight
		}
		else if(i==1) {
			spankSound = heavyImplementSound
			spanks = spanksHeavy
		}
		show("You have "+spanks+" swats coming to you with the "+implementArray[i]+", "+player+".")
		showButton("Yes, "+respectTitle+".")
		def messageArray = ["Alternate cheeks, HARD!",
			"Alternate cheeks, HARD!",
			"Alternate sit spots, HARD!",
			"Alternate cheeks, FAST!",
			"Two swats per cheek, alternating!"]
		switch(getRandom(5))
		{
			case 0: spank(messageArray[0],spanks,1.00);break
			case 1: spank(messageArray[1],spanks,1.25);break
			case 2: spank(messageArray[2],spanks,1.00);break
			case 3: spank(messageArray[3],spanks,0.75);break
			case 4: spank(messageArray[4],spanks,1.00);break
		}
		if(i<3)
		{
			def secMessageArray = ["I hope you're having as much fun as I am!",
				"Watching you spank yourself is so much fun!",
				"I'm so glad you decided to play this game with me.",
				"I hope you aren't regretting your decision to play with me?",
				"Awww, did that hurt?",
				"Is your bottom sore, "+player+"?"]
			show(secMessageArray[getRandom(6)])
			wait(5)
		}
	}
	setImageGame()
	show("All done, "+player+"!")
}

//Player won the game and gets to stroke
def payoutStroke = {
	setImageGame()
	show("I can't believe you beat me!\n\nWell, I guess you've earned the chance to wank."
		+"\n\nShow me that "+cockpussy+" of yours, young "+manlady+", and get ready for your reward.")
	showButton("Ready, "+respectTitle+".")

	def totalStrokes = coinsPlayer * strokeMultiplier
	def strokeRounds = (int) totalStrokes / 50
	def remainingStrokes = totalStrokes % 50

	def firstThird = (int) strokeRounds*(1.0/3)+1
	def finalThird = (int) strokeRounds*(2.0/3)+1

	def strokeTime = 1

	def message = "slow strokes"

	def i=1
	while(i <= strokeRounds)
	{
		if(i == firstThird && i >= 2)
		{
			setImageGame()
			strokeTime = 0.75
			message = "medium strokes"
		}
		else if(i==finalThird && i>=4)
		{
			setImageGame()
			strokeTime = 0.5
			message = "faster strokes"
		}
		else if(i == strokeRounds && i > 5)
		{
			setImageGame()
			strokeTime = 0.25
			message = "fast strokes"
		}
		if(i == strokeRounds) stroke(message,50+remainingStrokes,strokeTime)
		else stroke(message,50,strokeTime)
		i++
	}
	show("Did you enjoy that, "+player+"?\n\nI was looking forward to spanking you, "
		+"but I suppose you did win your reward fair and square... this time!")
	showButton("Thank you, "+respectTitle+".")
}

//Game ending
def gameEnd = {
	setImageGame()
	show("Game over!")
	wait(3)
	if(coinsPlayer<1) {
		show("Okay... time for your spanking, young "+manlady+"!")
		showButton("(Gulp!)")
		payoutSpank()
	}
	else {
		show("I can't believe you completely escaped a spanking from me this time!"
			+"\n\nAnd I was so looking forward to reddening your cheeks up, too!")
		showButton("I won!")
		payoutStroke()
	}
}

//Midround taunt message
def showMidroundMessage = {
	def midroundMessageArray
	if(coinsOpponent>coinsPlayer)
		midroundMessageArray = ["Looks like I'm winning, huh?",
			"Someone's going to get a spanking soon!",
			"Next round! Ready?",
			"Ready for the next round?"]
	else if(coinsPlayer>coinsOpponent)
		midroundMessageArray = ["I can't believe you're actually winning!",
			"Hmph! You won't be in the lead for long!",
			"Next round! Ready?",
			"Ready for the next round?"]
	else
		midroundMessageArray = ["Ooh, it's a close game!",
			"Isn't this exciting?",
			"Next round! Ready?",
			"Ready for the next round?"]
	show("You: "+coinsPlayer+" "+coin+"s.\n"+opponent+": "+coinsOpponent+" "+coin+"s."
		+"\n\n\n\n\n\n\n\n"+midroundMessageArray[getRandom(4)]+"")
}

//Install Check
def installed = loadBoolean("Banjo.games.installed")
if(installed==null) {
	installed = false
	save("Banjo.games.installed",installed)
}

def coreScript = new File("scripts/Banjo/gamehub.groovy")
if(coreScript.exists()) {
	installed = true
	save("Banjo.games.installed",installed)
}
else {
	installed = false
	save("Banjo.games.installed",installed)
}
if(!installed) {
	show(null)
	setImage(null)
	if(getBoolean("CORE FILES NOT FOUND!\n\n"
		+"This game requires the download of a 'core' pack of opponents, images, sounds and files that is shared by other games in this series."
		+"To download the needed files, simply go to the SexScripts website script database and search for 'Game Hub' (or the script tag 'banjohub').\n\n"
		+"The script downloads can be found at:\n\n"
		+"http://ss.deviatenow.com/scripts.php\n\n"
		+"Apologies for the inconvenience!"
		+"", "Go to Webpage","Exit")) {
			if(isConnected()) {
				useUrl("http://ss.deviatenow.com/scripts.php")
				getString("Your internet browser should have opened the correct download page.\n\n"
					+"If not, please copy the link below and paste it into your web browser.", "http://ss.deviatenow.com/scripts.php")
			}
			else {
				getString("Cannot connect to the internet (your firewall may be blocking this operation)\n\n"
					+"Please copy the link below and paste it into your web browser.", "http://ss.deviatenow.com/scripts.php")
			}
		}
		show(null)
		setImage(null)
		if(loadBoolean("setting.newsetup")) {
			if(loadBoolean("setting.reload")) {
				return "system/welcome"
			}
			else {
				return "system/exit"
			}
		}
		else {
			return null
		}
}

//Start of script
show(null)
setImage(null)
opponentSelect()
show(null)
setImageMain()
wait(1)
intro()
while(!quit) {
	if(getBoolean("Do you want to review the rules?","Yes","I know them")) {
		rulesDisplay()
		while(getBoolean("Do you need to go back over the rules again?","Yes","I understand them")) {
			rulesDisplay()
		}
	}
	if(loadBoolean("Banjo.fourheroes.implements_set")) {
		lightImplement = loadString("Banjo.fourheroes.lightImplement")
		heavyImplement = loadString("Banjo.fourheroes.heavyImplement")
		setImplementSounds()
		if(getBoolean("If you lose, you'll be spanked with the "+lightImplement+" and the "+heavyImplement+"."
			+"\n\nDo you want to change this?","Yes please","No thanks")) {
			pickImplements()
		}
	} else {
		show("Now, in case you lose, we will need to pick two implements...")
		showButton("Okay, "+respectTitle+".")
		pickImplements()
	}
	show("Now, let's play!")
	wait(3)
	setCoins()
	gamePlay = true
	while(gamePlay) {
		if(coinsPlayer<1) {
			gamePlay = false
		}
		else if(coinsOpponent<1) {
			gamePlay = false
		}
		else {
			gameRound()
			showMidroundMessage()
			setImageGame()
			showButton("Next round!")
			show("You: "+coinsPlayer+" "+coin+"s.\n"+opponent+": "+coinsOpponent+" "+coin+"s."
				+"\n\n\n\n\n\n\n\n...")
		}
	}
	gameEnd()
	setImageMain()
	show(goodbye1)
	showButton("Goodbye, "+respectTitle+".")
	quit = true
}
setImage(null)
show(null)
def quitGame = true
if(loadBoolean("Banjo.games.hub")) {
	if(getBoolean("Return to Game Hub?","Yes","No")) {
		quitGame = false
		save("Banjo.games.hub",false)
		return "Banjo/gamehub"
	} else save("Banjo.games.hub",false)
}
if(quitGame) {
	if(loadBoolean("setting.newsetup")) {
		if(loadBoolean("setting.reload")) {
			return "system/welcome"
		}
		else {
			return "system/exit"
		}
	}
	else {
		return null
	}
}

//END OF SCRIPT
